HDU-2377 Bus Pass

Bus Pass

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Problem Description
You travel a lot by bus and the costs of all the seperate tickets are starting to add up.

Therefore you want to see if it might be advantageous for you to buy a bus pass.

The way the bus system works in your country (and also in the Netherlands) is as follows:

when you buy a bus pass, you have to indicate a center zone and a star value. You are allowed to travel freely in any zone which has a distance to your center zone which is less than your star value. For example, if you have a star value of one, you can only travel in your center zone. If you have a star value of two, you can also travel in all adjacent zones, et cetera.

You have a list of all bus trips you frequently make, and would like to determine the minimum star value you need to make all these trips using your buss pass. But this is not always an easy task. For example look at the following figure:



Here you want to be able to travel from A to B and from B to D. The best center zone is 7400, for which you only need a star value of 4. Note that you do not even visit this zone on your trips!
 

Input
On the first line an integert(1 <=t<= 100): the number of test cases. Then for each test case:

One line with two integersnz(2 <=nz<= 9 999) andnr(1 <=nr<= 10): the number of zones and the number of bus trips, respectively.

nz lines starting with two integers id i (1 <= id i <= 9 999) and mz i (1 <= mz i <= 10), a number identifying the i-th zone and the number of zones adjacent to it, followed by mz i integers: the numbers of the adjacent zones.

nr lines starting with one integer mr i (1 <= mr i <= 20), indicating the number of zones the ith bus trip visits, followed by mr i integers: the numbers of the zones through which the bus passes in the order in which they are visited.

All zones are connected, either directly or via other zones.

 

Output
For each test case:

One line with two integers, the minimum star value and the id of a center zone which achieves this minimum star value. If there are multiple possibilities, choose the zone with the lowest number.

 

Sample Input
  
  
1 17 2 7400 6 7401 7402 7403 7404 7405 7406 7401 6 7412 7402 7400 7406 7410 7411 7402 5 7412 7403 7400 7401 7411 7403 6 7413 7414 7404 7400 7402 7412 7404 5 7403 7414 7415 7405 7400 7405 6 7404 7415 7407 7408 7406 7400 7406 7 7400 7405 7407 7408 7409 7410 7401 7407 4 7408 7406 7405 7415 7408 4 7409 7406 7405 7407 7409 3 7410 7406 7408 7410 4 7411 7401 7406 7409 7411 5 7416 7412 7402 7401 7410 7412 6 7416 7411 7401 7402 7403 7413 7413 3 7412 7403 7414 7414 3 7413 7403 7404 7415 3 7404 7405 7407 7416 2 7411 7412 5 7409 7408 7407 7405 7415 6 7415 7404 7414 7413 7412 7416


Sample Output
   
   
4 7400

 ————————————————————集训2.1的分割线————————————————————

前言:这道题还是比较丧病的。。。用来学习BFS+SPFA+邻接表

思路:首先目的是要找出某一个地区,到达所有车站的最大距离最小。那么反过来对每个车站跑一遍最短路。最坏20次,所以采用SPFA,见效快疗效好。每次跑完之后,得到一份单源最短路。枚举顶点,维护它的最大值,这么一来跑完所有车站之后得到的就是每个顶点和各个车站距离的最大值(最远的车站)。而要求的就是这个最大值最小的点。

PS.SPFA是对Bellman-Ford的改进(增加了队列),本质就是一个BFS。每进行一次松弛操作,都需要使得该松弛点进队,等待松弛。还有一点比较坑:输入的时候id可能不是增序,要输出id最小的还要进行排序。

代码如下:

/*
ID: j.sure.1
PROG:
LANG: C++
*/
/****************************************/
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <cmath>
#include <stack>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <iostream>
using namespace std;
/****************************************/
int n, bus;
const int MAXE = 200005, MAXN = 10000;
bool inq[MAXN];
int dis[MAXN], node[MAXN], maxd[MAXN], head[MAXN], id[MAXN];
struct Edge
{
	int u, v;
	int next;
} edge[MAXE];
int cnt;

void init()
{
	memset(head, -1, sizeof(head));
	cnt = 0;
	memset(maxd, 0, sizeof(maxd));
}

void add(int u, int v)
{
	edge[cnt].u = u;
	edge[cnt].v = v;
	edge[cnt].next = head[u];
	head[u] = cnt++;
}

void spfa(int st)
{
	memset(inq, 0, sizeof(inq));
	memset(dis, 0x7f, sizeof(dis));
	queue <int> q;
	q.push(st);
	dis[st] = 0;
	inq[st] = true;
	int tmp;
	while(!q.empty()) {
		tmp = q.front(); q.pop();
		inq[tmp] = false;
		for(int i = head[tmp]; i != -1; i = edge[i].next) {
			int v = edge[i].v;
			if(dis[v] > dis[tmp] + 1) {
				dis[v] = dis[tmp] + 1;
				if(!inq[v]) {
					q.push(v);
					inq[v] = true;
				}
			}
		}
	}
}

int main()
{
#ifndef ONLINE_JUDGE
    freopen("2377.in", "r", stdin);
    freopen("2377.out", "w", stdout);
#endif
    int T;
    scanf("%d", &T);
    for(int cas = 0; cas < T; cas++) {
        scanf("%d%d", &n, &bus);
        int adj;
        init();
        for(int i = 0; i < n; i++) {
            scanf("%d%d", &id[i], &adj);
            int v;
            while(adj--) {
				scanf("%d", &v);
				add(id[i], v);
				//add(v, id[i]);//因为数据齐全所以不需要
            }
        }
        while(bus--) {
			int stop;
			scanf("%d", &stop);
			while(stop--) {
				int st;
				scanf("%d", &st);
				spfa(st);
				for(int i = 0; i < n; i++) {
					if(dis[id[i]] > maxd[id[i]]) {
						maxd[id[i]] = dis[id[i]];
					}
				}
			}
        }
		//如果存在多个解 找到编号最小的
		int ans = 2e9, ans_id;
		sort(id, id+n);
		for(int i = 0; i < n; i++) if(ans > maxd[id[i]]) {
			ans = maxd[id[i]];
			ans_id = id[i];
		}
		printf("%d %d\n", ans+1, ans_id);
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值